## net.sf.saxon.option.dom4j
Class NodeWrapper

    java.lang.Object
      net.sf.saxon.option.dom4j.NodeWrapper

All Implemented Interfaces:
  Source, PullEvent, Item, NodeInfo, ValueRepresentation, SiblingCountingNode, VirtualNode

Direct Known Subclasses:
  DocumentWrapper

    public class NodeWrapper

extends Object
implements NodeInfo, VirtualNode, SiblingCountingNode

A node in the XML parse tree representing an XML element, character content, or attribute.

This is the implementation of the NodeInfo interface used as a wrapper for DOM4J nodes.

Author:
  Michael H. Kay

Field Summary
`protected DocumentWrapper` `docWrapper`
`protected int` `index`
`protected Object` `node`
`protected short` `nodeKind`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Constructor Summary
`protected` `NodeWrapper(Object node, NodeWrapper parent, int index)` This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class

Method Summary
`Value` `atomize()` Get the typed value.
`int` `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter (deep copy)
`void` `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node.
`String` `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`String` `getBaseURI()` Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
`int` `getColumnNumber()` Get column number
`Configuration` `getConfiguration()` Get the configuration used to build the tree containing this node.
`int[]` `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`String` `getDisplayName()` Get the display name of this node.
`long` `getDocumentNumber()` Get the document number of the document containing this node.
`DocumentInfo` `getDocumentRoot()` Get the root (document) node
`int` `getFingerprint()` Get fingerprint.
`int` `getLineNumber()` Get line number
`String` `getLocalPart()` Get the local part of the name of this node.
`int` `getNameCode()` Get name code.
`NamePool` `getNamePool()` Get the name pool for this node
`int` `getNodeKind()` Return the type of node.
`NodeInfo` `getParent()` Get the NodeInfo object representing the parent of this node
`String` `getPrefix()` Get the prefix part of the name of this node.
`Object` `getRealNode()` Get the node underlying this virtual node.
`NodeInfo` `getRoot()` Get the root node - always a document node with this tree implementation
`int` `getSiblingPosition()` Get the index position of this node among its siblings (starting from 0)
`String` `getStringValue()` Return the string value of the node.
`CharSequence` `getStringValueCS()` Get the string value of the item as a CharSequence.
`String` `getSystemId()` Get the System ID for the node.
`int` `getTypeAnnotation()` Get the type annotation
`SequenceIterator` `getTypedValue()` Get the typed value of the item
`Object` `getUnderlyingNode()` Get the underlying DOM node, to implement the VirtualNode interface
`String` `getURI()` Get the URI part of the name of this node.
`boolean` `hasChildNodes()` Determine whether the node has any children.
`boolean` `isId()` Determine whether this node has the is-id property
`boolean` `isIdref()` Determine whether this node has the is-idref property
`boolean` `isNilled()` Determine whether the node has the is-nilled property
`boolean` `isSameNode(NodeInfo other)` Determine whether this is the same node as another node.
`boolean` `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
`AxisIterator` `iterateAxis(byte axisNumber)` Return an iteration over the nodes reached by the given axis from this node
`AxisIterator` `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iteration over the nodes reached by the given axis from this node
`protected NodeWrapper` `makeWrapper(Object node, DocumentWrapper docWrapper)` Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.
`protected NodeWrapper` `makeWrapper(Object node, DocumentWrapper docWrapper, NodeWrapper parent, int index)` Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.
`void` `outputNamespaceNodes(Receiver out, boolean includeAncestors)` Output all namespace nodes associated with this element.
`void` `setSystemId(String uri)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`equals, hashCode`

Field Detail

### node

    protected Object node

### nodeKind

    protected short nodeKind

### docWrapper

    protected DocumentWrapper docWrapper

### index

    protected int index

Constructor Detail

### NodeWrapper

    protected NodeWrapper(Object node,
                          NodeWrapper parent,
                          int index)

  This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class

  Parameters:
    `node` - The DOM4J node to be wrapped
    `parent` - The NodeWrapper that wraps the parent of this node
    `index` - Position of this node among its siblings

Method Detail

### makeWrapper

    protected NodeWrapper makeWrapper(Object node,
                                      DocumentWrapper docWrapper)

  Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.

  Parameters:
    `node` - The DOM4J node
    `docWrapper` - The wrapper for the Document containing this node
  Returns:
    The new wrapper for the supplied node

### makeWrapper

    protected NodeWrapper makeWrapper(Object node,
                                      DocumentWrapper docWrapper,
                                      NodeWrapper parent,
                                      int index)

  Factory method to wrap a DOM4J node with a wrapper that implements the Saxon NodeInfo interface.

  Parameters:
    `node` - The DOM4J node
    `docWrapper` - The wrapper for the Document containing this node
    `parent` - The wrapper for the parent of the DOM4J node
    `index` - The position of this node relative to its siblings
  Returns:
    The new wrapper for the supplied node

### getUnderlyingNode

    public Object getUnderlyingNode()

  Get the underlying DOM node, to implement the VirtualNode interface

  Specified by:
    `getUnderlyingNode` in interface `VirtualNode`
  Returns:
    The underlying node.

### getRealNode

    public Object getRealNode()

  Get the node underlying this virtual node. If this is a VirtualNode the method will automatically drill down through several layers of wrapping.

  Specified by:
    `getRealNode` in interface `VirtualNode`
  Returns:
    The underlying node.

### getNamePool

    public NamePool getNamePool()

  Get the name pool for this node

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the NamePool

### getNodeKind

    public int getNodeKind()

  Return the type of node.

  Specified by:
    `getNodeKind` in interface `NodeInfo`
  Returns:
    one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
  See Also:
    `Type`

### getTypedValue

    public SequenceIterator getTypedValue()

  Get the typed value of the item

  Specified by:
    `getTypedValue` in interface `Item`
  Returns:
    an iterator over the items in the typed value of the node or atomic value. The items returned by this iterator will always be atomic values.

### atomize

    public Value atomize()

  Description copied from interface: `NodeInfo`
  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `NodeInfo`
  Returns:
    the typed value. This will either be a single AtomicValue or a Value whose items are atomic values.

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    UNTYPED or UNTYPED_ATOMIC

### isSameNode

    public boolean isSameNode(NodeInfo other)

  Determine whether this is the same node as another node.
  Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Parameters:
    `other` - the node to be compared with
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### getSystemId

    public String getSystemId()

  Get the System ID for the node.

  Specified by:
    `getSystemId` in interface `Source`
  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

### setSystemId

    public void setSystemId(String uri)

  Specified by:
    `setSystemId` in interface `Source`

### getBaseURI

    public String getBaseURI()

  Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. In the DOM4J model, base URIs are held only an the document level. We don't currently take any account of xml:base attributes.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

### getLineNumber

    public int getLineNumber()

  Get line number

  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### getColumnNumber

    public int getColumnNumber()

  Get column number

  Specified by:
    `getColumnNumber` in interface `NodeInfo`
  Returns:
    the column number of the node in its original source document; or -1 if not available

### compareOrder

    public int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getStringValue

    public String getStringValue()

  Return the string value of the node. The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in interface `NodeInfo`
  Specified by:
    `getStringValue` in interface `ValueRepresentation`
  Returns:
    the string value of the node
  See Also:
    `Item.getStringValueCS()`

### getStringValueCS

    public CharSequence getStringValueCS()

  Description copied from interface: `Item`
  Get the string value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String. The method satisfies the rule that `X.getStringValueCS().toString()` returns a string that is equal to `X.getStringValue()`.

  Note that two CharSequence values of different types should not be compared using equals(), and for the same reason they should not be used as a key in a hash table.

  If the calling code can handle any CharSequence, this method should be used. If the caller requires a string, the `Item.getStringValue()` method is preferred.

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### getNameCode

    public int getNameCode()

  Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with &0xfffff, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
  See Also:
    `allocate`

### getFingerprint

    public int getFingerprint()

  Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. A fingerprint of -1 should be returned for a node with no name.

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

### getLocalPart

    public String getLocalPart()

  Get the local part of the name of this node. This is the name after the ":" if any.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    the local part of the name. For an unnamed node, returns "".

### getPrefix

    public String getPrefix()

  Get the prefix part of the name of this node. This is the name before the ":" if any. (Note, this method isn't required as part of the NodeInfo interface.)

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    the prefix part of the name. For an unnamed node, return an empty string.

### getURI

    public String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For an unnamed node, return null. For a node with an empty prefix, return an empty string.

### getDisplayName

    public String getDisplayName()

  Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getParent

    public NodeInfo getParent()

  Get the NodeInfo object representing the parent of this node

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    the parent of this node; null if this node has no parent

### getSiblingPosition

    public int getSiblingPosition()

  Get the index position of this node among its siblings (starting from 0)

  Specified by:
    `getSiblingPosition` in interface `SiblingCountingNode`
  Returns:
    0 for the first child, 1 for the second child, etc.

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iteration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - the axis to be used
  Returns:
    a SequenceIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an iteration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - the axis to be used
    `nodeTest` - A pattern to be matched by the returned nodes
  Returns:
    a SequenceIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### getAttributeValue

    public String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getRoot

    public NodeInfo getRoot()

  Get the root node - always a document node with this tree implementation

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the containing document

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root (document) node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.
  Note: the result is equivalent to
  getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    True if the node has one or more children

### generateId

    public void generateId(FastStringBuffer buffer)

  Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Specified by:
    `generateId` in interface `NodeInfo`
  Parameters:
    `buffer` - a Buffer to contain a string that uniquely identifies this node, across all documents

### getDocumentNumber

    public long getDocumentNumber()

  Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`
  Returns:
    the document number of the document containing this node

### copy

    public void copy(Receiver out,
                     int copyOptions,
                     int locationId)
              throws XPathException

  Copy this node to a given outputter (deep copy)

  Specified by:
    `copy` in interface `NodeInfo`
  Parameters:
    `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
    `copyOptions` - a selection of the options defined in `CopyOptions`
    `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
  Throws:
    `XPathException`

### outputNamespaceNodes

    public void outputNamespaceNodes(Receiver out,
                                     boolean includeAncestors)
                              throws XPathException

  Output all namespace nodes associated with this element. Does nothing if the node is not an element.

  Parameters:
    `out` - The relevant outputter
    `includeAncestors` - True if namespaces declared on ancestor elements must be output; false if it is known that these are already on the result tree
  Throws:
    `XPathException`

### isId

    public boolean isId()

  Determine whether this node has the is-id property

  Specified by:
    `isId` in interface `NodeInfo`
  Returns:
    true if the node is an ID. For DOM4J, this always returns false, because no information about attribute types is available.

### isIdref

    public boolean isIdref()

  Determine whether this node has the is-idref property

  Specified by:
    `isIdref` in interface `NodeInfo`
  Returns:
    true if the node is an IDREF or IDREFS element or attribute. For DOM4J, this always returns false, because no information about attribute types is available.

### isNilled

    public boolean isNilled()

  Determine whether the node has the is-nilled property

  Specified by:
    `isNilled` in interface `NodeInfo`
  Returns:
    true if the node has the is-nilled property. For DOM4J, this always returns false

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node. Note: a.isSameNodeInfo(b) if and only if generateId(a)==generateId(b). This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.

### getConfiguration

    public Configuration getConfiguration()

  Description copied from interface: `NodeInfo`
  Get the configuration used to build the tree containing this node.

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Returns:
    the Configuration

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.